diff --git a/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java b/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
index 82a1a4cab..50656deab 100644
--- a/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
+++ b/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
@@ -62,6 +62,9 @@ class WorkbenchGenerator {
         generateDyeingRecipes();
 
         generateStatueRecipes();
+        generateAcidConversions();
+
+        generateMiscNewRecipes();
 
         RecipeBuilder.Shaped(CORE_NAMESPACE)
                 .setShape(
@@ -151,11 +154,11 @@ class WorkbenchGenerator {
                 "###",
                 "CSR",
                 "###")
-            .addInput('#', Blocks.COBBLE_NETHERRACK)
+            .addInput('#', Blocks.NETHERRACK)
             .addInput('S', Blocks.SOULSAND)
             .addInput('C', Blocks.CONDUIT)
             .addInput('R', Items.DUST_REDSTONE)
-            .create("activator", Blocks.ACTIVATOR_COBBLE_NETHERRACK.getDefaultStack());
+            .create("activator", Blocks.ACTIVATOR.getDefaultStack());
 
         RecipeBuilder.Shaped(CORE_NAMESPACE)
             .setShape(
@@ -254,7 +257,7 @@ class WorkbenchGenerator {
         shape22.addInput('#', Items.CLAY).create("clay_block", Blocks.BLOCK_CLAY.getDefaultStack());
         shape22.addInput('#', Items.AMMO_SNOWBALL).create("snow_block", Blocks.BLOCK_SNOW.getDefaultStack());
         shape22.addInput('#', Items.STRING).create("string_to_wool", Blocks.WOOL.getDefaultStack());
-        shape22.addInput('#', Items.AMMO_PEBBLE).create("pebbles_to_cobblestone", Blocks.COBBLE_STONE.getDefaultStack());
+        shape22.addInput('#', Items.AMMO_PEBBLE).create("pebbles_to_cobblestone", new ItemStack(Blocks.COBBLE_STONE, 2));
         shape22.addInput('#', Blocks.SAND).create("sandstone", new ItemStack(Blocks.SANDSTONE, 2));
         shape22.addInput('#', "minecraft:planks").create("workbench", Blocks.WORKBENCH.getDefaultStack());
 
@@ -429,7 +432,59 @@ class WorkbenchGenerator {
             .addInput(new ItemStack(Items.DYE, 1, DyeColor.BLACK.itemMeta))
             .addInput(Items.STRING)
             .create("blank_label", Items.LABEL.getDefaultStack());
+
+        RecipeBuilder.Shapeless(CORE_NAMESPACE)
+            .addInput(Items.BONE)
+            .addInput(Items.BONE)
+            .create("bone_pile", Blocks.BONE_PILE.getDefaultStack());
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "GSG",
+                "SCS",
+                "GSG")
+            .addInput('C', Items.NETHERCOAL)
+            .addInput('G', Items.GUNPOWDER)
+            .addInput('S', Items.SULFUR)
+            .create("ember", Blocks.EMBER.getDefaultStack());
+
+        RecipeBuilder.Shapeless(CORE_NAMESPACE)
+            .addInput(Items.SULFUR)
+            .addInput(Items.COAL)
+            .addInput(Items.PAPER)
+            .create("gunpowder_with_coal", new ItemStack(Items.GUNPOWDER, 2));
+
+        RecipeBuilder.Shapeless(CORE_NAMESPACE)
+            .addInput(Items.SULFUR)
+            .addInput(new ItemStack(Items.COAL, 1, 1))
+            .addInput(Items.PAPER)
+            .create("gunpowder_with_charcoal", new ItemStack(Items.GUNPOWDER, 2));
+
+        RecipeBuilder.Shapeless(CORE_NAMESPACE)
+            .addInput(Items.SULFUR)
+            .addInput(Items.NETHERCOAL)
+            .addInput(Items.PAPER)
+            .create("gunpowder_with_nethercoal", new ItemStack(Items.GUNPOWDER, 4));
+
+        RecipeBuilder.Shapeless(CORE_NAMESPACE)
+            .addInput(Blocks.RUBYGLASS_COLUMN)
+            .create("ruby_column_to_growth", new ItemStack(Blocks.RUBYGLASS_GROWTH, 4));
+
+        RecipeBuilder.Shapeless(CORE_NAMESPACE)
+            .addInput(Blocks.RUBYGLASS_GROWTH)
+            .addInput(Blocks.RUBYGLASS_GROWTH)
+            .addInput(Blocks.RUBYGLASS_GROWTH)
+            .addInput(Blocks.RUBYGLASS_GROWTH)
+            .create("ruby_growth_to_column", new ItemStack(Blocks.RUBYGLASS_COLUMN, 1));
+
+        RecipeBuilder.Shapeless(CORE_NAMESPACE)
+            .addInput(Items.SULFUR)
+            .addInput(Items.CLAY)
+            .addInput(new ItemStack(Items.DYE, 1, DyeColor.WHITE.itemMeta))
+            .create("dirt", new ItemStack(Blocks.DIRT, 2));
     }
+
+
     private static void generatePickaxes() {
         RecipeBuilderShaped pickaxeTemplate = RecipeBuilder.Shaped(CORE_NAMESPACE)
             .setShape(
@@ -732,7 +787,7 @@ class WorkbenchGenerator {
         block.addInput('X', Items.DIAMOND).create("block_of_diamond", Blocks.BLOCK_DIAMOND.getDefaultStack());
         block.addInput('X', Items.QUARTZ).create("block_of_quartz", Blocks.BLOCK_QUARTZ.getDefaultStack());
         block.addInput('X', Items.SUGARCANE).create("block_of_sugarcane", Blocks.BLOCK_SUGARCANE.getDefaultStack());
-        block.addInput('X', Items.RUBYGLASS_CRYSTAL).create("block_of_rubyglass", Blocks.BLOCK_RUBYGLASS.getDefaultStack());
+        block.addInput('X', Items.RUBYGLASS).create("block_of_rubyglass", Blocks.BLOCK_RUBYGLASS.getDefaultStack());
 
         blockFuel.addInput('X', Items.COAL, 0).create("block_of_coal", Blocks.BLOCK_COAL.getDefaultStack());
         blockFuel.addInput('X', Items.COAL, 1).create("block_of_charcoal", Blocks.BLOCK_CHARCOAL.getDefaultStack());
@@ -748,7 +803,7 @@ class WorkbenchGenerator {
         RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.BLOCK_REDSTONE).create("block_of_redstone_to_redstone", new ItemStack(Items.DUST_REDSTONE, 9));
         RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.BLOCK_DIAMOND).create("block_of_diamond_to_diamond", new ItemStack(Items.DIAMOND, 9));
         RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.BLOCK_QUARTZ).create("block_of_quartz_to_quartz", new ItemStack(Items.QUARTZ, 9));
-        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.BLOCK_RUBYGLASS).create("block_of_rubyglass_to_rubyglass", new ItemStack(Items.RUBYGLASS_CRYSTAL, 9));
+        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.BLOCK_RUBYGLASS).create("block_of_rubyglass_to_rubyglass", new ItemStack(Items.RUBYGLASS, 9));
         RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.BLOCK_SUGARCANE).create("block_of_sugarcane_to_sugarcane", new ItemStack(Items.SUGARCANE, 9));
 
         RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.BLOCK_COAL).create("block_of_coal_to_coal", new ItemStack(Items.COAL, 8, 0));
@@ -765,6 +820,7 @@ class WorkbenchGenerator {
             );
 
         final int stackSize = 4;
+        bricks.addInput('X', Items.RUBYGLASS).create("rubyglass_bricks", new ItemStack(Blocks.BRICK_RUBYGLASS, stackSize));
         bricks.addInput('X', Items.DIAMOND).create("diamond_bricks", new ItemStack(Blocks.BRICK_DIAMOND, stackSize));
         bricks.addInput('X', Items.BRICK_CLAY).create("clay_bricks", new ItemStack(Blocks.BRICK_CLAY, stackSize));
         bricks.addInput('X', Items.INGOT_GOLD).create("golden_bricks", new ItemStack(Blocks.BRICK_GOLD, stackSize));
@@ -830,6 +886,7 @@ class WorkbenchGenerator {
         slabs.addInput('X', Blocks.BRICK_NETHERRACK).create("netherrack_brick_slab", new ItemStack(Blocks.SLAB_BRICK_NETHERRACK, stackSize));
         slabs.addInput('X', Blocks.BRICK_GLOOMSTONE).create("gloomstone_brick_slab", new ItemStack(Blocks.SLAB_BRICK_GLOOMSTONE, stackSize));
 
+        slabs.addInput('X', Blocks.BRICK_RUBYGLASS).create("rubyglass_brick_slab", new ItemStack(Blocks.SLAB_BRICK_RUBYGLASS, stackSize));
         slabs.addInput('X', Blocks.BRICK_DIAMOND).create("diamond_brick_slab", new ItemStack(Blocks.SLAB_BRICK_DIAMOND, stackSize));
         slabs.addInput('X', Blocks.BRICK_IRON).create("iron_brick_slab", new ItemStack(Blocks.SLAB_BRICK_IRON, stackSize));
         slabs.addInput('X', Blocks.BRICK_GOLD).create("gold_brick_slab", new ItemStack(Blocks.SLAB_BRICK_GOLD, stackSize));
@@ -880,6 +937,7 @@ class WorkbenchGenerator {
         stairs.addInput('X', Blocks.BRICK_NETHERRACK).create("netherrack_brick_stairs", new ItemStack(Blocks.STAIRS_BRICK_NETHERRACK, stackSize));
         stairs.addInput('X', Blocks.BRICK_GLOOMSTONE).create("gloomstone_brick_stairs", new ItemStack(Blocks.STAIRS_BRICK_GLOOMSTONE, stackSize));
 
+        stairs.addInput('X', Blocks.BRICK_RUBYGLASS).create("rubyglass_brick_stairs", new ItemStack(Blocks.STAIRS_BRICK_RUBYGLASS, stackSize));
         stairs.addInput('X', Blocks.BRICK_DIAMOND).create("diamond_brick_stairs", new ItemStack(Blocks.STAIRS_BRICK_DIAMOND, stackSize));
         stairs.addInput('X', Blocks.BRICK_IRON).create("iron_brick_stairs", new ItemStack(Blocks.STAIRS_BRICK_IRON, stackSize));
         stairs.addInput('X', Blocks.BRICK_GOLD).create("gold_brick_stairs", new ItemStack(Blocks.STAIRS_BRICK_GOLD, stackSize));
@@ -1384,7 +1442,7 @@ class WorkbenchGenerator {
                 "#C#",
                 "#Q#"
             )
-            .addInput('#', Blocks.COBBLE_NETHERRACK)
+            .addInput('#', Blocks.NETHERRACK)
             .addInput('Q', Items.QUARTZ)
             .addInput('C', Blocks.CONDUIT)
             .create("matcher", new ItemStack(Blocks.MATCHER, 1));
@@ -1395,8 +1453,8 @@ class WorkbenchGenerator {
                         "ORO",
                         "XOX")
                 .addInput('R', Items.DUST_REDSTONE)
-                .addInput('O', Items.RUBYGLASS_CRYSTAL)
-                .addInput('X', Blocks.COBBLE_NETHERRACK)
+                .addInput('O', Items.RUBYGLASS)
+                .addInput('X', Blocks.NETHERRACK)
                 .create("conduit", new ItemStack(Blocks.CONDUIT, 1));
 
         RecipeBuilder.Shaped(CORE_NAMESPACE)
@@ -1431,18 +1489,14 @@ class WorkbenchGenerator {
     }
 
     private static void generateStatueRecipes() {
-        final String[] statueNames = new String[]{"stone", "basalt", "limestone", "granite", "marble"};
-        final Item[] statueItems = new Item[]{Items.STATUE_STONE, Items.STATUE_BASALT, Items.STATUE_LIMESTONE, Items.STATUE_GRANITE, Items.STATUE_MARBLE};
-        final Block<?>[] statueBodyBlocks = new Block[]{Blocks.STONE, Blocks.BASALT, Blocks.LIMESTONE, Blocks.GRANITE, Blocks.MARBLE};
-        final Block<?>[] statueBaseBlocks = new Block[]{Blocks.SLAB_STONE_POLISHED, Blocks.SLAB_BASALT_POLISHED, Blocks.SLAB_LIMESTONE_POLISHED, Blocks.SLAB_GRANITE_POLISHED, Blocks.SLAB_CAPSTONE_MARBLE};
+        final String[] statueNames = new String[]{"stone", "basalt", "limestone", "granite", "marble", "slate", "permafrost", "netherrack", "gloomstone"};
+        final Item[] statueItems = new Item[]{Items.STATUE_STONE, Items.STATUE_BASALT, Items.STATUE_LIMESTONE, Items.STATUE_GRANITE, Items.STATUE_MARBLE, Items.STATUE_SLATE, Items.STATUE_PERMAFROST, Items.STATUE_NETHERRACK, Items.STATUE_GLOOMSTONE};
+        final Block<?>[] statueBodyBlocks = new Block[]{Blocks.STONE, Blocks.BASALT, Blocks.LIMESTONE, Blocks.GRANITE, Blocks.MARBLE, Blocks.SLATE, Blocks.PERMAFROST, Blocks.NETHERRACK, Blocks.GLOOMSTONE};
+        final Block<?>[] statueBaseBlocks = new Block[]{Blocks.SLAB_STONE_POLISHED, Blocks.SLAB_BASALT_POLISHED, Blocks.SLAB_LIMESTONE_POLISHED, Blocks.SLAB_GRANITE_POLISHED, Blocks.SLAB_CAPSTONE_MARBLE, Blocks.SLAB_SLATE_POLISHED, Blocks.SLAB_PERMAFROST_POLISHED, Blocks.SLAB_NETHERRACK_POLISHED, Blocks.SLAB_GLOOMSTONE_POLISHED};
 
         for (int i = 0; i < statueItems.length; i++) {
             RecipeBuilder.Shaped(CORE_NAMESPACE)
-                .setShape(
-                    "#",
-                    "#",
-                    "_"
-                )
+                    .setShape("#", "#", "_")
                 .addInput('#', statueBodyBlocks[i])
                 .addInput('_', statueBaseBlocks[i])
                 .create("statue_" + statueNames[i], new ItemStack(statueItems[i], 1));
@@ -1484,4 +1538,64 @@ class WorkbenchGenerator {
         Registries.RECIPES.WORKBENCH.register(String.format(format, "buttons_planks"), new RecipeEntryDyeing(new RecipeSymbol("minecraft:button_planks"), new ItemStack(Blocks.BUTTON_PLANKS_PAINTED), true, false));
         Registries.RECIPES.WORKBENCH.register(String.format(format, "pressureplates_planks"), new RecipeEntryDyeing(new RecipeSymbol("minecraft:pressureplates_planks"), new ItemStack(Blocks.PRESSURE_PLATE_PLANKS_OAK_PAINTED), true, false));
     }
+
+    private static void generateMiscNewRecipes() {
+        // Carved Stones
+        RecipeBuilderShaped templateCarvedStone = RecipeBuilder.Shaped(CORE_NAMESPACE).setShape("SS", "SS");
+        templateCarvedStone.addInput('S', Blocks.STONE_POLISHED).create("carved_stone", new ItemStack(Blocks.STONE_CARVED, 2));
+        templateCarvedStone.addInput('S', Blocks.BASALT_POLISHED).create("carved_basalt", new ItemStack(Blocks.BASALT_CARVED, 2));
+        templateCarvedStone.addInput('S', Blocks.LIMESTONE_POLISHED).create("carved_limestone", new ItemStack(Blocks.LIMESTONE_CARVED, 2));
+        templateCarvedStone.addInput('S', Blocks.GRANITE_POLISHED).create("carved_granite", new ItemStack(Blocks.GRANITE_CARVED, 2));
+        templateCarvedStone.addInput('S', Blocks.PERMAFROST_POLISHED).create("carved_permafrost", new ItemStack(Blocks.PERMAFROST_CARVED, 2));
+        templateCarvedStone.addInput('S', Blocks.MARBLE).create("marble_capstone", new ItemStack(Blocks.CAPSTONE_MARBLE, 2));
+        templateCarvedStone.addInput('S', Blocks.SLATE_POLISHED).create("carved_slate", new ItemStack(Blocks.SLATE_CARVED, 2));
+        templateCarvedStone.addInput('S', Blocks.NETHERRACK_POLISHED).create("carved_netherrack", new ItemStack(Blocks.NETHERRACK_CARVED, 2));
+        templateCarvedStone.addInput('S', Blocks.GLOOMSTONE_POLISHED).create("carved_gloomstone", new ItemStack(Blocks.GLOOMSTONE_CARVED, 2));
+
+        // Brimstone Formatting
+        RecipeBuilder.Shaped(CORE_NAMESPACE).setShape("SS", "SS").addInput('S', Blocks.BRIMSAND).create("brimstone", new ItemStack(Blocks.BRIMSTONE, 2));
+        RecipeBuilder.Shaped(CORE_NAMESPACE).setShape("SSS").addInput('S', Blocks.BRIMSTONE).create("brimstone_slab", new ItemStack(Blocks.SLAB_BRIMSTONE, 6));
+        RecipeBuilder.Shaped(CORE_NAMESPACE).setShape("S  ", "SS ", "SSS").addInput('S', Blocks.BRIMSTONE).create("brimstone_stairs", new ItemStack(Blocks.STAIRS_BRIMSTONE, 6));
+        RecipeBuilder.Shaped(CORE_NAMESPACE).setShape("SS", "SS").addInput('S', Blocks.BRIMSTONE).create("brimstone_bricks", new ItemStack(Blocks.BRICK_BRIMSTONE, 4));
+        RecipeBuilder.Shaped(CORE_NAMESPACE).setShape("SSS").addInput('S', Blocks.BRICK_BRIMSTONE).create("brick_brimstone_slab", new ItemStack(Blocks.SLAB_BRICK_BRIMSTONE, 6));
+        RecipeBuilder.Shaped(CORE_NAMESPACE).setShape("S  ", "SS ", "SSS").addInput('S', Blocks.BRICK_BRIMSTONE).create("brick_brimstone_stairs", new ItemStack(Blocks.STAIRS_BRICK_BRIMSTONE, 6));
+
+        // Misc additions
+        RecipeBuilder.Shaped(CORE_NAMESPACE).setShape("SSS").addInput('S', Blocks.SLATE_POLISHED).create("polished_slate_slab", new ItemStack(Blocks.SLAB_SLATE_POLISHED, 6));
+        RecipeBuilder.Shaped(CORE_NAMESPACE).setShape("PO", "OP").addInput('P', Items.AMMO_PEBBLE).addInput('O', Blocks.OBSIDIAN).create("pebbles_to_gloomstone", new ItemStack(Blocks.COBBLE_GLOOMSTONE, 2));
+        RecipeBuilder.Shaped(CORE_NAMESPACE).setShape(" S ", "SAS", " S ").addInput('S', Items.SULFUR).addInput('A', Items.AMMO_ARROW).create("flaming_arrow", new ItemStack(Items.AMMO_ARROW_FLAMING, 4));
+        RecipeBuilder.Shaped(CORE_NAMESPACE).setShape("SS", "SS").addInput('S', Items.SULFUR).create("sulfur_block", new ItemStack(Blocks.SULFUR, 1));
+
+        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.LOG_SCORCHED).create("scorched_log_to_black_wooden_planks", new ItemStack(Blocks.PLANKS_OAK_PAINTED, 4, 15));
+    }
+
+    private static void generateAcidConversions() {
+        // Each pair: { input, output }
+        final Block<?>[][] pairs = {
+            { Blocks.COBBLE_STONE,         Blocks.STONE       },
+            { Blocks.COBBLE_BASALT,        Blocks.BASALT      },
+            { Blocks.COBBLE_LIMESTONE,     Blocks.LIMESTONE   },
+            { Blocks.COBBLE_GRANITE,       Blocks.GRANITE     },
+            { Blocks.COBBLE_PERMAFROST,    Blocks.PERMAFROST  },
+            { Blocks.COBBLE_NETHERRACK,    Blocks.NETHERRACK  },
+            { Blocks.COBBLE_GLOOMSTONE,    Blocks.GLOOMSTONE  },
+            { Blocks.SAND,                 Blocks.SANDSTONE   },
+            { Blocks.BRIMSAND,             Blocks.BRIMSTONE   }
+        };
+
+        for (Block<?>[] pair : pairs) {
+            Block<?> cobble = pair[0];
+            Block<?> smooth = pair[1];
+            String cobbleName = cobble.getKey().replace(".", "_").replace(":", "_");
+
+            RecipeBuilder.Shaped(CORE_NAMESPACE)
+                .setShape(
+                    "CCC",
+                    "CAC",
+                    "CCC")
+                .addInput('C', cobble)
+                .addInput('A', "minecraft:acid_buckets")
+                .create("acid_conversion_" + cobbleName, new ItemStack(smooth, 4));
+        }
+    }
 }
diff --git a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTABiome.java b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTABiome.java
index cb9b399df..bd6bb7962 100644
--- a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTABiome.java
+++ b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTABiome.java
@@ -1,6 +1,5 @@
 package org.useless.seedviewer.bta;
 
-import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.util.HardIllegalArgumentException;
 import net.minecraft.core.util.collection.NamespaceID;
@@ -19,8 +18,12 @@ public class BTABiome implements ViewerBiome {
 
     @Override
     public NamespaceID getID() {
+        final String key = this.biome.getRegistryKey();
+        if (key == null) {
+            throw new IllegalArgumentException("Unregistered biome: " + this.biome.translationKey);
+        }
         try {
-            return NamespaceID.fromPool(Registries.BIOMES.getKey(this.biome)).copyUnpooled();
+            return NamespaceID.fromPool(key).copyUnpooled();
         } catch (HardIllegalArgumentException e) {
             throw new IllegalArgumentException(e);
         }
